//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Green
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_width1  1


//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    HalfLength11 = 24;
extern int    HalfLength12 = 6;
extern int    HalfLength21 = 12;
extern int    HalfLength22 = 3;
extern int    Price       = PRICE_CLOSE;
extern bool   Invert      = false;


double buffer1[];


string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(1);
   SetIndexBuffer(1,buffer1);

      if ((HalfLength11%2)==0) HalfLength11++;
      if ((HalfLength12%2)==0) HalfLength12++;
      if ((HalfLength21%2)==0) HalfLength21++;
      if ((HalfLength22%2)==0) HalfLength22++;
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }




//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][12];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      int limit=MathMin(Bars-counted_bars+MathMax(HalfLength11,HalfLength12)*5,Bars-1);
      if (returnBars) { buffer4[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      if (slope[limit]==-1) CleanPoint(limit,buffer2,buffer3);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)  work[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][1] = iCTma(0,HalfLength11,i);
         work[r][2] = iCTma(0,HalfLength12,i);
         if (Invert)
               work[r][3] = 100.0*(work[r][2]-work[r][1]);
         else  work[r][3] = 100.0*(work[r][1]-work[r][2]);
      }  
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][4] = iCTma(3,HalfLength12,i);
         work[r][5] = 100.0*(work[r][4]-work[r-1][4]);
      }
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][6] = iCTma(5,HalfLength12,i);
         work[r][7] = 100.0*(work[r][6]-work[r-1][6]);
      }
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][8] = iCTma(7,HalfLength12,i);
         work[r][9] = work[r][8]-work[r-1][8];
      }
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][10] = iCTma(9,HalfLength12,i);
         work[r][11] = work[r][10]-work[r-1][10];
           
           

   
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      if (slope[limit]==-1) CleanPoint(limit,buffer2,buffer3);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)  work[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][12] = iCTma(0,HalfLength1,i);
         work[r][13] = iCTma(0,HalfLength2,i);
         if (Invert)
               work[r][14] = 100.0*(work[r][13]-work[r][12]);
         else  work[r][14] = 100.0*(work[r][12]-work[r][13]);
      }  
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][15] = iCTma(14,HalfLength22,i);
         work[r][16] = 100.0*(work[r][15]-work[r-1][15]);
      }
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][17] = iCTma(16,HalfLength22,i);
         work[r][18] = 100.0*(work[r][17]-work[r-1][17]);
      }
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][19] = iCTma(18,HalfLength22,i);
         work[r][20] = work[r]19]-work[r-1][19];
      }
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][21] = iCTma(20,HalfLength22,i);
         work[r][22] = work[r][21]-work[r-1]21];
            buffer1[i] = work[r][10]+work[r][22];
            buffer2[i] = EMPTY_VALUE;
            buffer3[i] = EMPTY_VALUE;
            buffer4[i] = work[r][11];
            slope[i]   = slope[i+1];
               if (buffer1[i]>buffer1[i+1]) slope[i]= 1;
               if (buffer1[i]<buffer1[i+1]) slope[i]=-1;
               if (slope[i]==-1) PlotPoint(i,buffer2,buffer3,buffer1);
      }
      return(0);
   }   
   
   }
   
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,buffer2,buffer3);
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            buffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HalfLength1,HalfLength2,Price,Invert,0,y);
            buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HalfLength11,HalfLength12,HalfLength21,HalfLength22, Price,Invert,1,y);
            slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HalfLength1,HalfLength2,Price,Invert,4,y);
            buffer2[i] = EMPTY_VALUE;
            buffer3[i] = EMPTY_VALUE;
            if (slope[i]==-1) PlotPoint(i,buffer2,buffer3,buffer1);            
   }
   return(0);   
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double iCTma(int useValue, int halfLength, int i)
{
   i = Bars-i-1;
   
   //
   //
   //
   //
   //
      
   double sum  = (halfLength+1)*work[i][useValue];
   double sumw = (halfLength+1);
 
      //
      //
      //
      //
      //
 
      int j,k = halfLength; 
      for(j=1; j<=halfLength; j++,k--)
      {
         sum  += k*work[i-j][useValue];
         sumw += k;
            int l = MathMin(j+i,Bars-1);
               sum  += k*work[l][useValue];
               sumw += k;
      }
   return(sum/sumw);      
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H2","150m","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,120,150,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}